gstreamermm: Gst::AppSink Class Reference

gstreamermm 1.4.3

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gst::AppSink Class Reference
gstreamermm Plugins

A Wrapper for the appsink plugin. More...

Inheritance diagram for Gst::AppSink:
[legend]
Collaboration diagram for Gst::AppSink:
[legend]

## Public Member Functions
virtual | ~AppSink ()
GstAppSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstAppSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstAppSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Sample > | pull_preroll ()
| This is a convenience method for the action signal signal_pull_preroll(). More...
Glib::RefPtr< Gst::Sample > | pull_sample ()
| This is a convenience method for the action signal signal_pull_sample(). More...
Glib::PropertyProxy < Glib::RefPtr< Gst::Caps > > | property_caps ()
| The allowed caps for the sink pad. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gst::Caps > > | property_caps () const
| The allowed caps for the sink pad. More...
Glib::PropertyProxy_ReadOnly < bool > | property_eos () const
| Check if the sink is EOS or not started. More...
Glib::PropertyProxy< bool > | property_emit_signals ()
| Emit new-preroll and new-sample signals. More...
Glib::PropertyProxy_ReadOnly < bool > | property_emit_signals () const
| Emit new-preroll and new-sample signals. More...
Glib::PropertyProxy< guint > | property_max_buffers ()
| The maximum number of buffers to queue internally (0 = unlimited). More...
Glib::PropertyProxy_ReadOnly < guint > | property_max_buffers () const
| The maximum number of buffers to queue internally (0 = unlimited). More...
Glib::PropertyProxy< bool > | property_drop ()
| Drop old buffers when the buffer queue is filled. More...
Glib::PropertyProxy_ReadOnly < bool > | property_drop () const
| Drop old buffers when the buffer queue is filled. More...
Glib::SignalProxy0< void > | signal_eos ()
Glib::SignalProxy0 < Gst::FlowReturn > | signal_new_preroll ()
Glib::SignalProxy0 < Gst::FlowReturn > | signal_new_sample ()
Glib::SignalProxy0 < Glib::RefPtr< Gst::Sample > > | signal_pull_preroll ()
| This is an action signal which is designed to be used as a method. More...
Glib::SignalProxy0 < Glib::RefPtr< Gst::Sample > > | signal_pull_sample ()
| This is an action signal which is designed to be used as a method. More...
Public Member Functions inherited from Gst::BaseSink
virtual | ~BaseSink ()
GstBaseSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstBaseSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstBaseSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | query_latency (bool& live, bool& upstream_live, ClockTime& min_latency, ClockTime& max_latency) const
| Query the sink for the latency parameters. More...
ClockTime | get_latency () const
| Get the currently configured latency. More...
Gst::FlowReturn | do_preroll (const Glib::RefPtr< Gst::MiniObject >& obj)
| If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. More...
FlowReturn | wait_preroll ()
| If the Gst::BaseSinkClass.render() method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data. More...
ClockReturn | wait_clock (ClockTime time, ClockTimeDiff& jitter)
| This function will block until time is reached. More...
FlowReturn | wait (ClockTime time, ClockTimeDiff& jitter)
| This function will wait for preroll to complete and will then block until time is reached. More...
ClockReturn | wait_clock (ClockTime time)
| This function will block until time is reached. More...
FlowReturn | wait (ClockTime time)
| This function will block until time is reached. More...
void | set_sync (bool sync)
| Configures sink to synchronize on the clock or not. More...
bool | get_sync () const
| Checks if sink is currently configured to synchronize against the clock. More...
void | set_max_lateness (gint64 max_lateness)
| Sets the new max lateness value to max_lateness. More...
gint64 | get_max_lateness () const
| Gets the max lateness value. More...
void | set_qos_enabled (bool enabled)
| Configures sink to send Quality-of-Service events upstream. More...
bool | is_qos_enabled () const
| Checks if sink is currently configured to send Quality-of-Service events upstream. More...
void | set_async_enabled (bool enabled)
| Configures sink to perform all state changes asynchronusly. More...
bool | is_async_enabled () const
| Checks if sink is currently configured to perform asynchronous state changes to PAUSED. More...
void | set_ts_offset (ClockTimeDiff offset)
| Adjust the synchronisation of sink with offset. More...
ClockTimeDiff | get_ts_offset () const
| Get the synchronisation offset of sink. More...
void | set_render_delay (ClockTime delay)
| Set the render delay in sink to delay. More...
ClockTime | get_render_delay () const
| Get the render delay of sink. More...
void | set_blocksize (guint blocksize)
| Set the number of bytes that the sink will pull when it is operating in pull mode. More...
guint | get_blocksize () const
| Get the number of bytes that the sink will pull when it is operating in pull mode. More...
guint64 | get_throttle_time () const
| Get the time that will be inserted between frames to control the maximum buffers per second. More...
void | set_throttle_time (guint64 throttle)
| Set the time that will be inserted between rendered buffers. More...
Glib::RefPtr< Gst::Pad > | get_sink_pad ()
| Gets the sink Gst::Pad object of the element. More...
Glib::RefPtr< const Gst::Pad > | get_sink_pad () const
Glib::PropertyProxy< bool > | property_async ()
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy_ReadOnly < bool > | property_async () const
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy< gint64 > | property_max_lateness ()
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy_ReadOnly < gint64 > | property_max_lateness () const
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy< bool > | property_qos ()
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy_ReadOnly < bool > | property_qos () const
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy< bool > | property_sync ()
| Sync on the clock. More...
Glib::PropertyProxy_ReadOnly < bool > | property_sync () const
| Sync on the clock. More...
Glib::PropertyProxy< gint64 > | property_ts_offset ()
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy_ReadOnly < gint64 > | property_ts_offset () const
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_render_delay ()
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_render_delay () const
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_throttle_time ()
| The time to keep between rendered buffers (0 = disabled). More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_throttle_time () const
| The time to keep between rendered buffers (0 = disabled). More...
Glib::PropertyProxy< guint > | property_blocksize ()
| Size in bytes to pull per buffer (0 = default). More...
Glib::PropertyProxy_ReadOnly < guint > | property_blocksize () const
| Size in bytes to pull per buffer (0 = default). More...
virtual Glib::RefPtr< Gst::Caps > | get_caps_vfunc (Glib::RefPtr< Gst::Caps > caps) const
| Called to get sink pad caps from the subclass. More...
virtual bool | set_caps_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Notify subclass of changed caps. More...
virtual void | get_times_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer, ClockTime& start, ClockTime&end) const
| Called to get the start and end times for synchronising the passed buffer to the clock. More...
virtual bool | start_vfunc ()
| Start processing. More...
virtual bool | stop_vfunc ()
| Stop processing. More...
virtual bool | unlock_vfunc ()
| Unlock any pending access to the resource. More...
virtual bool | event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Override this to handle events arriving on the sink pad. More...
virtual FlowReturn | preroll_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called to present the preroll buffer if desired. More...
virtual FlowReturn | render_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called when a buffer should be presented or output, at the correct moment if the Gst::BaseSink has been set to sync to the clock. More...
virtual bool | activate_pull_vfunc (bool active)
| Subclasses should override this when they need to perform special processing when changing to the PLAYING state asynchronously. More...
virtual Glib::RefPtr< Gst::Caps > | fixate_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Only useful in pull mode, this vmethod will be called in response to Gst::Pad::fixate_caps() being called on the sink pad. More...
virtual bool | unlock_stop_vfunc ()
| Clear the previous unlock request. More...
virtual FlowReturn | render_list_vfunc (const Glib::RefPtr< Gst::BufferList >& buffer_list)
| Render a BufferList. More...
Public Member Functions inherited from Gst::Element
virtual | ~Element ()
GstElement* | gobj ()
| Provides access to the underlying C GObject. More...
const GstElement* | gobj () const
| Provides access to the underlying C GObject. More...
GstElement* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest)
| Links this source element to the element. More...
bool | add_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Adds a pad (link point) to element. More...
void | create_all_pads ()
| Creates a pad for each pad template that is always available. More...
Glib::RefPtr< Gst::Pad > | create_compatible_pad (const Glib::RefPtr< const Gst::Pad >& pad, const Glib::RefPtr< const Gst::Caps >& caps)
| Looks for an unlinked pad to which the given pad can link. More...
Glib::RefPtr< Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl)
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< const Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl) const
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< Gst::Pad > | get_request_pad (const Glib::ustring& name)
| Retrieves a pad from the element by name (e.g. "src_\\%d"). More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Retrieves a request pad from the element according to the provided template. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::RefPtr< const Gst::Caps >& caps)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | get_static_pad (const Glib::ustring& name)
| Retrieves a pad from element by name. More...
Glib::RefPtr< const Gst::Pad > | get_static_pad (const Glib::ustring& name) const
| Retrieves a pad from element by name. More...
void | no_more_pads ()
| Use this function to signal that the element does not expect any more pads to show up in the current pipeline. More...
void | release_request_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Makes the element free the previously requested pad as obtained with get_request_pad(). More...
bool | remove_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Removes pad from element. More...
Gst::Iterator< Gst::Pad > | iterate_pads ()
| Retrieves an iterator of element's pads. More...
Gst::Iterator< const Gst::Pad > | iterate_pads () const
| Retrieves an iterator of element's pads. More...
Gst::Iterator< Gst::Pad > | iterate_sink_pads ()
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< const Gst::Pad > | iterate_sink_pads () const
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< Gst::Pad > | iterate_src_pads ()
| Retrieves an iterator of element's source pads. More...
Gst::Iterator< const Gst::Pad > | iterate_src_pads () const
| Retrieves an iterator of element's source pads. More...
void | unlink (const Glib::RefPtr< Gst::Element >& dest)
| Unlinks all source pads of the source element with all sink pads of the sink element to which they are linked. More...
void | set_context (const Glib::RefPtr< Gst::Context >& context)
| Sets the context of the element. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Links the two named pads of the source and destination elements. More...
void | unlink_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Unlinks the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, const Glib::RefPtr< Gst::Caps >& filter)
| Links the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, PadLinkCheck flags)
| Links the two named pads of the source and destination elements. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest, const Glib::RefPtr< Gst::Caps >& filter)
| Links src to dest using the given caps as filtercaps. More...
void | set_base_time (ClockTime time)
| Set the base time of an element. More...
ClockTime | get_base_time () const
| Returns the base time of the element. More...
void | set_start_time (Gst::ClockTime time)
| Set the start time of an element. More...
Gst::ClockTime | get_start_time () const
| Returns the start time of the element. More...
void | set_bus (const Glib::RefPtr< Gst::Bus >& bus)
| Sets the bus of the element. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Returns the bus of the element. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Returns the bus of the element. More...
Glib::RefPtr< Gst::ElementFactory > | get_factory ()
| Retrieves the factory that was used to create this element. More...
Glib::RefPtr< const Gst::ElementFactory > | get_factory () const
| Retrieves the factory that was used to create this element. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Sets the clock for the element. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the currently configured clock of the element. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the currently configured clock of the element. More...
Glib::RefPtr< Gst::Clock > | provide_clock ()
| Get the clock provided by the given element. More...
Glib::RefPtr< const Gst::Clock > | provide_clock () const
| Get the clock provided by the given element. More...
StateChangeReturn | set_state (State state)
| Sets the state of the element. More...
StateChangeReturn | get_state (State& state, State& pending, ClockTime timeout) const
| Gets the state of the element. More...
bool | set_locked_state (gboolean locked_state)
| Locks the state of an element, so state changes of the parent don't affect this element anymore. More...
bool | is_locked_state () const
| Checks if the state of an element is locked. More...
void | abort_state ()
| Abort the state change of the element. More...
StateChangeReturn | continue_state (StateChangeReturn ret)
| Commit the state change of the element and proceed to the next pending state if any. More...
void | lost_state ()
| Brings the element to the lost state. More...
bool | sync_state_with_parent ()
| Tries to change the state of the element to the same as its parent. More...
StateChangeReturn | change_state (StateChange transition)
| Perform transition on element. More...
void | post_message (int code, int line, MessageType type=Gst::MESSAGE_INFO, const Glib::QueryQuark& domain=get_core_error_quark(), const Glib::ustring& text=Glib::ustring(), const Glib::ustring& debug=Glib::ustring(), const Glib::ustring& file=Glib::ustring(), const Glib::ustring& function=Glib::ustring())
| Post an error, warning or info message on the bus from inside an element. More...
bool | post_message (const Glib::RefPtr< Gst::Message >& message)
| Post a message on the element's Gst::Bus. More...
bool | query (const Glib::RefPtr< Gst::Query >& query) const
| Performs a query on the given element. More...
bool | query_convert (Gst::Format src_format, gint64 src_val, Format dest_format, gint64& dest_val) const
| Queries an element to convert src_val in src_format to dest_format. More...
bool | query_position (Gst::Format format, gint64& cur) const
| Queries an element (usually top-level pipeline or playbin element) for the stream position in nanoseconds. More...
bool | query_position (Gst::Format format) const
| Queries an element for the stream position. More...
bool | query_duration (Gst::Format format, gint64& duration) const
| Queries an element (usually top-level pipeline or playbin element) for the total stream duration in nanoseconds. More...
bool | query_duration (Gst::Format format) const
| Queries an element for the total stream duration. More...
bool | seek (Format format, SeekFlags seek_flags, gint64 seek_pos)
| Simple API to perform a seek on the given element, meaning it just seeks to the given position relative to the start of the stream. More...
bool | seek (double rate, Format format, SeekFlags flags, SeekType cur_type, gint64 cur, SeekType stop_type, gint64 stop)
| Sends a seek event to an element. More...
bool | send_event (const Glib::RefPtr< Gst::Event >& event)
| Sends an event to an element. More...
Glib::SignalProxy0< void > | signal_no_more_pads ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_added ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_removed ()
virtual void | release_pad_vfunc (const Glib::RefPtr< Gst::Pad >& pad)
| Called when a request pad is to be released. More...
virtual Glib::RefPtr< Gst::Pad > | request_new_pad_vfunc (Glib::RefPtr< Gst::PadTemplate > templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Called when a new pad is requested. More...
virtual StateChangeReturn | get_state_vfunc (State& state, State& pending, ClockTime timeout) const
| Get the state of the element. More...
virtual StateChangeReturn | set_state_vfunc (State state)
| Set a new state on the element. More...
virtual StateChangeReturn | change_state_vfunc (StateChange transition)
| Called by set_state to perform an incremental state change. More...
virtual void | set_bus_vfunc (const Glib::RefPtr< Gst::Bus >& bus)
| Set a Gst::Bus on the element. More...
virtual Glib::RefPtr< Gst::Clock > | provide_clock_vfunc ()
| Gets the Gst::Clock provided by the element. More...
virtual bool | set_clock_vfunc (const Glib::RefPtr< Gst::Clock >& clock)
| Set the Gst::Clock on the element. More...
virtual bool | send_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Send a Gst::Event to the element. More...
virtual bool | query_vfunc (const Glib::RefPtr< Gst::Query >&query) const
| Perform a Gst::Query on the element. More...
virtual void | set_context_vfunc (const Glib::RefPtr< Gst::Context >& context)
| Set a Gst::Context on the element. More...
Glib::RefPtr< Gst::PadTemplate > | get_pad_template (const Glib::ustring& factory_name) const
template<typename T >
Glib::RefPtr< Gst::Element > | property (const Glib::ustring& name, const T& value)
| Sets specified property. More...
Public Member Functions inherited from Gst::Object
virtual | ~Object ()
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `0`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the object. More...
Glib::SignalProxy2< void, const Glib::RefPtr< Object > &, GParamSpec* > | signal_deep_notify ()
int | get_refcount () const
Public Member Functions inherited from Gst::URIHandler
virtual | ~URIHandler ()
GstURIHandler* | gobj ()
| Provides access to the underlying C GObject. More...
const GstURIHandler* | gobj () const
| Provides access to the underlying C GObject. More...
URIType | get_uri_type () const
| Gets the type of the given URI handler. More...
std::vector< Glib::ustring > | get_protocols () const
| Gets the list of protocols supported by handler. More...
Glib::ustring | get_uri () const
| Gets the currently handled URI. More...
bool | set_uri (const Glib::ustring& uri)
| Tries to set the URI of the given handler. More...
virtual Glib::ustring | get_uri_vfunc () const
| Virtual method which should be implemented to return the URI currently handled by the element. More...
virtual bool | set_uri_vfunc (const Glib::ustring& uri, GError** error)
| Virtual method which should be implemented to set a new URI. More...
virtual const gchar* const* | get_protocols_vfunc () const
| Method to return the list of protocols handled by the element. More...
virtual URIType | get_type_vfunc ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< AppSink > | create ()
| Creates a new appsink plugin with a unique name. More...
static Glib::RefPtr< AppSink > | create (const Glib::ustring& name)
| Creates a new appsink plugin with the given name. More...
Static Public Member Functions inherited from Gst::BaseSink
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Element
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...
Static Public Member Functions inherited from Gst::URIHandler
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | protocol_is_valid (const Glib::ustring& protocol)
| Tests if the given string is a valid protocol identifier. More...
static bool | protocol_is_supported (const URIType type, const Glib::ustring& protocol)
| Checks if an element exists that supports the given URI protocol. More...
static bool | uri_is_valid (const Glib::ustring& uri)
| Tests if the given string is a valid URI identifier. More...
static bool | uri_has_protocol (const Glib::ustring& uri, const Glib::ustring& protocol)
| Checks if the protocol of a given valid URI matches protocol. More...
static Glib::ustring | get_protocol (const Glib::ustring& uri)
| Extracts the protocol out of a given valid URI. More...
static Glib::ustring | get_location (const Glib::ustring& uri)
| Extracts the location out of a given valid URI, ie. More...
static Glib::ustring | construct_uri (const Glib::ustring& protocol, const Glib::ustring& location)
| Constructs a URI for a given valid protocol and location. More...
static Glib::ustring | filename_to_uri (const Glib::ustring& filename)
| Similar to Glib::filename_to_uri(), but attempts to handle relative file paths as well. More...
static Glib::RefPtr< Gst::Element > | make_element_from_uri (const URIType type, const Glib::ustring& uri, const Glib::ustring& name)
| Creates an element for handling the given URI. More...

## Protected Member Functions
| AppSink ()
| AppSink (const Glib::ustring& name)
Protected Member Functions inherited from Gst::Element
virtual void | on_no_more_pads ()
| This is a default handler for the signal signal_no_more_pads(). More...
virtual void | on_pad_added (const Glib::RefPtr< Gst::Pad >& new_pad)
| This is a default handler for the signal signal_pad_added(). More...
virtual void | on_pad_removed (const Glib::RefPtr< Gst::Pad >& old_pad)
| This is a default handler for the signal signal_pad_removed(). More...
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...
Protected Member Functions inherited from Gst::URIHandler
| URIHandler ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::AppSink > | wrap (GstAppSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::BaseSink
Glib::RefPtr< Gst::BaseSink > | wrap (GstBaseSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Element
Glib::RefPtr< Gst::Element > | wrap (GstElement* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::URIHandler
Glib::RefPtr< Gst::URIHandler > | wrap (GstURIHandler* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A Wrapper for the appsink plugin.

Please note that not all plug-ins are available on all systems so care must be taken that they exist before they are used otherwise there will be errors and possibly a crash.

## Constructor & Destructor Documentation

virtual Gst::AppSink::~AppSink | ( |  | ) |
| virtual

Gst::AppSink::AppSink | ( |  | ) |
| protected

Gst::AppSink::AppSink | ( | const Glib::ustring & | name | ) |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<AppSink> Gst::AppSink::create | ( |  | ) |
| static

Creates a new appsink plugin with a unique name.

static Glib::RefPtr<AppSink> Gst::AppSink::create | ( | const Glib::ustring & | name | ) |
| static

Creates a new appsink plugin with the given name.

static GType Gst::AppSink::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GstAppSink* Gst::AppSink::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GstAppSink* Gst::AppSink::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GstAppSink* Gst::AppSink::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy< Glib::RefPtr<Gst::Caps> > Gst::AppSink::property_caps | ( |  | ) |

The allowed caps for the sink pad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gst::Caps> > Gst::AppSink::property_caps | ( |  | ) | const

The allowed caps for the sink pad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::AppSink::property_drop | ( |  | ) |

Drop old buffers when the buffer queue is filled.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::AppSink::property_drop | ( |  | ) | const

Drop old buffers when the buffer queue is filled.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gst::AppSink::property_emit_signals | ( |  | ) |

Emit new-preroll and new-sample signals.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::AppSink::property_emit_signals | ( |  | ) | const

Emit new-preroll and new-sample signals.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::AppSink::property_eos | ( |  | ) | const

Check if the sink is EOS or not started.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< guint > Gst::AppSink::property_max_buffers | ( |  | ) |

The maximum number of buffers to queue internally (0 = unlimited).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint > Gst::AppSink::property_max_buffers | ( |  | ) | const

The maximum number of buffers to queue internally (0 = unlimited).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::RefPtr<Gst::Sample> Gst::AppSink::pull_preroll | ( |  | ) |

This is a convenience method for the action signal signal_pull_preroll().

Glib::RefPtr<Gst::Sample> Gst::AppSink::pull_sample | ( |  | ) |

This is a convenience method for the action signal signal_pull_sample().

Glib::SignalProxy0< void > Gst::AppSink::signal_eos | ( |  | ) |

Slot Prototype:
  `void on_my_eos()`

Signal that the end-of-stream has been reached. This signal is emitted from the steaming thread.

Glib::SignalProxy0< Gst::FlowReturn > Gst::AppSink::signal_new_preroll | ( |  | ) |

Slot Prototype:
  `Gst::FlowReturn on_my_new_preroll()`

Signal that a new preroll sample is available.

This signal is emitted from the steaming thread and only when the "emit-signals" property is `true`.

The new preroll sample can be retrieved with the "pull-preroll" action signal or Gst::AppSink::pull_preroll() either from this signal callback or from any other thread.

Note that this signal is only emitted when the "emit-signals" property is set to `true`, which it is not by default for performance reasons.

Glib::SignalProxy0< Gst::FlowReturn > Gst::AppSink::signal_new_sample | ( |  | ) |

Slot Prototype:
  `Gst::FlowReturn on_my_new_sample()`

Signal that a new sample is available.

This signal is emitted from the steaming thread and only when the "emit-signals" property is `true`.

The new sample can be retrieved with the "pull-sample" action signal or Gst::AppSink::pull_sample() either from this signal callback or from any other thread.

Note that this signal is only emitted when the "emit-signals" property is set to `true`, which it is not by default for performance reasons.

Glib::SignalProxy0< Glib::RefPtr<Gst::Sample> > Gst::AppSink::signal_pull_preroll | ( |  | ) |

This is an action signal which is designed to be used as a method.

To do that, use its convenience method, pull_preroll().

Slot Prototype:
  `Glib::RefPtr<Gst::Sample> on_my_pull_preroll()`

Get the last preroll sample in appsink. This was the sample that caused the appsink to preroll in the PAUSED state. This sample can be pulled many times and remains available to the application even after EOS.

This function is typically used when dealing with a pipeline in the PAUSED state. Calling this function after doing a seek will give the sample right after the seek position.

Note that the preroll sample will also be returned as the first sample when calling Gst::AppSink::pull_sample() or the "pull-sample" action signal.

If an EOS event was received before any buffers, this function returns `0`. Use Gst::AppSink::is_eos() to check for the EOS condition.

This function blocks until a preroll sample or EOS is received or the appsink element is set to the READY/`0` state.

Returns
  A Gst::Sample or `0` when the appsink is stopped or EOS.

Glib::SignalProxy0< Glib::RefPtr<Gst::Sample> > Gst::AppSink::signal_pull_sample | ( |  | ) |

This is an action signal which is designed to be used as a method.

To do that, use its convenience method, pull_sample().

Slot Prototype:
  `Glib::RefPtr<Gst::Sample> on_my_pull_sample()`

This function blocks until a sample or EOS becomes available or the appsink element is set to the READY/`0` state.

This function will only return samples when the appsink is in the PLAYING state. All rendered samples will be put in a queue so that the application can pull samples at its own rate.

Note that when the application does not pull samples fast enough, the queued samples could consume a lot of memory, especially when dealing with raw video frames. It's possible to control the behaviour of the queue with the "drop" and "max-buffers" properties.

If an EOS event was received before any buffers, this function returns `0`. Use Gst::AppSink::is_eos() to check for the EOS condition.

Returns
  A Gst::Sample or `0` when the appsink is stopped or EOS.

## Friends And Related Function Documentation

Glib::RefPtr< Gst::AppSink > wrap | ( | GstAppSink * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gstreamermm/appsink.h